
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_composite_path_extract_value(documentdb_core.bson, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_composite_path_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_composite_path_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal)
 RETURNS internal
 LANGUAGE c
 PARALLEL SAFE STABLE
AS 'MODULE_PATHNAME', $function$gin_bson_composite_path_extract_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_composite_path_consistent(internal, smallint, anyelement, integer, internal, internal)
 RETURNS boolean
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_composite_path_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_composite_path_compare_partial(bytea, bytea, int2, internal)
 RETURNS int4
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 AS 'MODULE_PATHNAME', $function$gin_bson_composite_path_compare_partial$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_composite_path_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_composite_path_options$function$;
CREATE OPERATOR CLASS documentdb_api_internal.bson_rum_composite_path_ops
    FOR TYPE documentdb_core.bson using documentdb_rum AS
        OPERATOR 1 documentdb_api_catalog.@= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 2 documentdb_api_catalog.@> (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 3 documentdb_api_catalog.@>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 4 documentdb_api_catalog.@< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 5 documentdb_api_catalog.@<= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 6 documentdb_api_catalog.@*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 7 documentdb_api_catalog.@!= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 8 documentdb_api_catalog.@!*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 9 documentdb_api_catalog.@~ (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 10 documentdb_api_catalog.@? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 11 documentdb_api_catalog.@@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 12 documentdb_api_catalog.@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 13 documentdb_api_catalog.@&= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 14 documentdb_api_catalog.=?= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 15 documentdb_api_catalog.@!& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 16 documentdb_api_catalog.@!| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 17 documentdb_api_catalog.@#? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 18 documentdb_api_catalog.@& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 19 documentdb_api_catalog.@| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 20 documentdb_api_catalog.@% (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 25 documentdb_api_catalog.@<> (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 26 documentdb_api_internal.@!> (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 27 documentdb_api_internal.@!>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 28 documentdb_api_internal.@!< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 29 documentdb_api_internal.@!<= (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_api_catalog.gin_bson_compare(bytea, bytea),
        FUNCTION 2 documentdb_api_internal.gin_bson_composite_path_extract_value(documentdb_core.bson, internal),
        FUNCTION 3 documentdb_api_internal.gin_bson_composite_path_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_internal.gin_bson_composite_path_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 5 documentdb_api_internal.gin_bson_composite_path_compare_partial(bytea, bytea, int2, internal),
        FUNCTION 11 (documentdb_core.bson) documentdb_api_internal.gin_bson_composite_path_options(internal),
    STORAGE bytea;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_expression_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson, collationString text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE CALLED ON NULL INPUT
AS 'MODULE_PATHNAME', $function$bson_expression_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_expression_map(document documentdb_core.bson, sourceArrayName text, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_map$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_map(document documentdb_core.bson, sourceArrayName text, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_map$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson, collationString text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE CALLED ON NULL INPUT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_by_fields_get(document documentdb_core.bson, expressionSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_by_fields_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api.insert(
    p_database_name text,
    p_insert documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence default NULL,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert$$;
COMMENT ON FUNCTION documentdb_api.insert(text,documentdb_core.bson,documentdb_core.bsonsequence,text)
    IS 'inserts documents into a collection for a mongo wire protocol command';
CREATE OR REPLACE FUNCTION documentdb_api_internal.insert_one(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_document documentdb_core.bson,
    p_transaction_id text)
 RETURNS bool
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert_one$$;
COMMENT ON FUNCTION documentdb_api_internal.insert_one(bigint,bigint,documentdb_core.bson,text)
    IS 'internal command to insert one document into a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.insert_worker(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_shard_oid regclass,
    p_insert_internal_spec documentdb_core.bson,
    p_insert_internal_docs documentdb_core.bsonsequence,
    p_transaction_id text)
 RETURNS documentdb_core.bson
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert_worker$$;
CREATE OR REPLACE PROCEDURE documentdb_api.insert_bulk(
    IN p_database_name text,
    IN p_insert documentdb_core.bson,
    IN p_insert_documents documentdb_core.bsonsequence default NULL,
    IN p_transaction_id text default NULL,
    INOUT p_result documentdb_core.bson default NULL,
    INOUT p_success boolean default NULL)
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert_bulk$$;
COMMENT ON PROCEDURE documentdb_api.insert_bulk(text,documentdb_core.bson,documentdb_core.bsonsequence,text,documentdb_core.bson,boolean)
    IS 'inserts documents into a collection for a mongo wire protocol command outside transaction';
CREATE OR REPLACE FUNCTION documentdb_api.update(
    p_database_name text,
    p_update documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence default NULL,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_update$$;
COMMENT ON FUNCTION documentdb_api.update(text,documentdb_core.bson,documentdb_core.bsonsequence,text)
    IS 'update documents in a collection';
CREATE OR REPLACE PROCEDURE documentdb_api.update_bulk(
    p_database_name text,
    p_update documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence DEFAULT NULL,
    p_transaction_id text DEFAULT NULL,
    p_result INOUT documentdb_core.bson DEFAULT NULL,
    p_success INOUT boolean DEFAULT NULL)
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_update_bulk$$;
COMMENT ON PROCEDURE documentdb_api.update_bulk(text,documentdb_core.bson,documentdb_core.bsonsequence,text,documentdb_core.bson,boolean)
    IS 'update documents in a collection in a non-transactional manner';
CREATE OR REPLACE FUNCTION documentdb_api_internal.update_one(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_query documentdb_core.bson,
    p_update documentdb_core.bson,
    p_shard_key documentdb_core.bson,
    p_is_upsert bool,
    p_sort documentdb_core.bson,
    p_return_old_or_new bool,
    p_return_fields documentdb_core.bson,
    p_array_filters documentdb_core.bson,
    p_transaction_id text,
 OUT o_is_row_updated bool,
    OUT o_update_skipped bool,
 OUT o_is_retry bool,
 OUT o_reinsert_document documentdb_core.bson,
 OUT o_upserted_object_id bytea,
 OUT o_result_document documentdb_core.bson)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_update_one$$;
COMMENT ON FUNCTION documentdb_api_internal.update_one(bigint,bigint,documentdb_core.bson,documentdb_core.bson,documentdb_core.bson,bool,documentdb_core.bson,bool,documentdb_core.bson,documentdb_core.bson,text)
    IS 'updates a single document in a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.update_worker(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_shard_oid regclass,
    p_update_internal_spec documentdb_core.bson,
    p_update_internal_docs documentdb_core.bsonsequence,
    p_transaction_id text)
 RETURNS documentdb_core.bson
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_update_worker$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_update_returned_value(shard_key_id bigint)
 RETURNS int
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_update_returned_value$function$;
